/* Tabela PRESDIET: Prescrio Diettica */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela PRESDIET */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela PRESDIET utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_DIH_PRESDIET
AFTER DELETE OR INSERT OR UPDATE
ON PRESDIET FOR EACH ROW
DECLARE
  V_USUARIO    VARCHAR2(40);
  V_TIPO       VARCHAR2(1);
  V_ITPESQ     VARCHAR2(40);
  V_DESC       VARCHAR2(300);
  V_DTOPER     DATE;
  V_DSIP       VARCHAR2(50);
  V_DSUSUARIO  VARCHAR2(50);
  V_DSRDM      VARCHAR2(50);
  V_DSMETODO   VARCHAR2(250);
  V_DSOPERADOR VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';
   WEBTUNNING(V_DSIP,
              V_DSUSUARIO,
              V_DSRDM,
              V_DSMETODO,
              V_DSOPERADOR);
   IF DELETING THEN
      IF :OLD.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Fili=' || :OLD.CDFILIAL;
      END IF;
      IF :OLD.CDPACIENTE IS NOT NULL THEN
         V_DESC := V_DESC || ' CodPaci=' || :OLD.CDPACIENTE;
      END IF;
      IF :OLD.DTPRESDIET IS NOT NULL THEN
         V_DESC := V_DESC || ' DtPresc=' || TO_CHAR(:OLD.DTPRESDIET,'DD/MM/YYYY HH24:MI:SS');
      END IF;
      IF :OLD.CDDIETPAD IS NOT NULL THEN
         V_DESC := V_DESC || ' CodDiet=' || :OLD.CDDIETPAD;
      END IF;
      IF :OLD.CDNIASNUTR IS NOT NULL THEN
         V_DESC := V_DESC || ' NivelNutr=' || :OLD.CDNIASNUTR;
      END IF;

      V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
      V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
      V_DESC := V_DESC || ' Ip='       || V_DSIP;
      V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
      V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDFILIAL||:OLD.CDPACIENTE||:OLD.DTPRESDIET;
   ELSE

     IF UPDATING  THEN
        IF (:OLD.CDFILIAL     <> :NEW.CDFILIAL)    OR
           (:OLD.CDPACIENTE   <> :NEW.CDPACIENTE)  OR
           (:OLD.DTPRESDIET   <> :NEW.DTPRESDIET)  OR
           (:OLD.CDDIETPAD    <> :NEW.CDDIETPAD)   OR
           (:OLD.CDNIASNUTR   <> :NEW.CDNIASNUTR)  THEN
           V_TIPO         := '2';
           V_ITPESQ       := :OLD.CDFILIAL||:OLD.CDPACIENTE||:OLD.DTPRESDIET;
         END IF;
     ELSE
        V_TIPO         := '1';
        V_ITPESQ       := :NEW.CDFILIAL||:NEW.CDPACIENTE||:NEW.DTPRESDIET;
     END IF;

     IF :NEW.CDFILIAL IS NOT NULL THEN
         V_DESC := V_DESC || 'Fili=' || :NEW.CDFILIAL;
     END IF;
     IF :NEW.CDPACIENTE IS NOT NULL THEN
         V_DESC := V_DESC || ' CodPaci=' || :NEW.CDPACIENTE;
     END IF;
     IF :NEW.DTPRESDIET IS NOT NULL THEN
         V_DESC := V_DESC || ' DtPresc=' || TO_CHAR(:NEW.DTPRESDIET,'DD/MM/YYYY HH24:MI:SS');
     END IF;
     IF :NEW.CDDIETPAD IS NOT NULL THEN
         V_DESC := V_DESC || ' CodDiet=' || :NEW.CDDIETPAD;
     END IF;
     IF :NEW.CDNIASNUTR IS NOT NULL THEN
         V_DESC := V_DESC || ' NivelNutr=' || :NEW.CDNIASNUTR;
     END IF;

     V_DESC := V_DESC || ' Rdm='      || V_DSRDM;
     V_DESC := V_DESC || ' Mtodo='   || V_DSMETODO;
     V_DESC := V_DESC || ' Ip='       || V_DSIP;
     V_DESC := V_DESC || ' Usurio='  || V_DSUSUARIO;
     V_DESC := V_DESC || ' Operador=' || V_DSOPERADOR;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER, IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
            VALUES
               ('PRESDIET', V_DTOPER, V_USUARIO, V_TIPO, V_ITPESQ, SUBSTR(V_DESC, 1, 300),
                V_DSRDM, V_DSIP, V_DSUSUARIO, V_DSMETODO, V_DSOPERADOR, NVL(:NEW.CDFILIAL, :OLD.CDFILIAL));
         END IF;
      END IF;
   END IF;
END;
/


-- VERSAO --
BEGIN ATUVEROBJ('LOG_DIH_PRESDIET','4.11.083'); END;
/

